 processor 6502

	ORG $801
	.byte    $0E, $08, $0A, $00, $9E, $20, $28
	.byte   $32,$30,$36,$34
	.byte    $29, $00, $00, $00

	ORG $810
MyProgram
	jsr init_random_call
	jsr initsine_calculate
	jmp block7295
index	dc.b	
bgcol	dc.b	0
k3	dc.b	0
x	dc.b	0
y	dc.b	0
time	dc.b	0
time2	dc.b	0
idx	dc.b	0
i	dc.b	0
j	dc.b	0
road	dc.b	0
k	dc.b	0
ms_shift	dc.b	0
k2	dc.b	0
current	dc.b	0
ffld	dc.b	0
val	dc.b	0
a	dc.b	0
b	dc.b	0
cur_col	dc.b	0
cur_start	dc.b	0
l	dc.b	0
m	dc.b	0
dy	dc.b	0
scroll	dc.b	0
dscroll	dc.b	0
sx	dc.b	1
dsx	dc.b	1
tt	dc.b	1
speed	dc.b	1
cc	dc.b	0
i_	dc.b	0
k_	dc.b	0
k2_	dc.b	0
j_	dc.b	0
shifts	dc.b	 
	org shifts+16
shifts2	dc.b	 
	org shifts2+16
int	dc.w	
colorsRedhues	dc.b 0, 11, 0, 0, 
roads	dc.b 240, 0, 224, 1, 192, 3, 128, 7
	dc.b 0, 15, 0, 30, 0, 60, 0, 120
	dc.b 0, 240, 1, 224, 3, 192, 7, 128
	dc.b 15, 0, 28, 0, 56, 0, 112, 0
	dc.b 
sine2	dc.b	 
	org sine2+256
tab	dc.b	 
	org tab+256
waves		dc.b	"LEMONSPAWN  "
	dc.b	255
	dc.b	"PRESENTS    "
	dc.b	255
	dc.b	"$4K         "
	dc.b	255
	dc.b	"DREAMS     "
	dc.b	255
	dc.b	"CODE        "
	dc.b	255
	dc.b	"LEUAT        "
	dc.b	255
	dc.b	"MUSIC        "
	dc.b	255
	dc.b	"WARLORD      "
	dc.b	255
	dc.b	"DEVELOPED      "
	dc.b	255
	dc.b	"WITH        "
	dc.b	255
	dc.b	"TRSE        "
	dc.b	255
	dc.b	0
	dc.b	0
star_x	dc.b	 
	org star_x+24
star_dx	dc.b	 
	org star_dx+24
star_ddx	dc.b	 
	org star_ddx+24
zp	= $02
p1	= $04
p2	= $08
tp	= $16
tp2	= $0B
p3	= $0D
p4	= $10
zp2	= $12
fontTable	dc.b 32, 126, 124, 226, 108, 127, 225, 251
	dc.b 123, 97, 255, 236, 98, 252, 254, 83
	dc.b 
fadeBlue	dc.b 11, 6, 6, 12, 4, 14, 15, 1
	dc.b 1, 15, 14, 4, 12, 6, 6, 11
	dc.b 
text		dc.b	"         LEMONSPAWN PRESENTS      $4K DREAMS       A SMALL CRACKTRO          PARTICIPATING IN THE 2018 CSDB INTRO CREATION COMPETITION                "
	dc.b	" CODE LEUAT      MUSIC WARLORD       THANKS TO EVERYONE WHO ARE SUPPORTING THE CONTINUOUS DEVELOPMENT OF TRSE                 "
	dc.b	0
data	dc.b 191, 30, 75, 31, 
	
	
	; ***********  Defining procedure : RasterLower
	;    Procedure type : User-defined procedure
	
	rti
	
	
	; ***********  Defining procedure : init16x8div
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
divisor = $4c     ;$59 used for hi-byte
dividend = $4e	  ;$fc used for hi-byte
remainder = $50	  ;$fe used for hi-byte
result = $4e ;save memory by reusing divident to store the result
divide16x8	lda #0	        ;preset remainder to 0
	sta remainder
	sta remainder+1
	ldx #16	        ;repeat for each bit: ...
divloop16	asl dividend	;dividend lb & hb*2, msb -> Carry
	rol dividend+1
	rol remainder	;remainder lb & hb * 2 + msb from carry
	rol remainder+1
	lda remainder
	sec
	sbc divisor	;substract divisor to see if it fits in
	tay	        ;lb result -> Y, for we may need it later
	lda remainder+1
	sbc divisor+1
	bcc skip16	;if carry=0 then divisor didn't fit in yet
	sta remainder+1	;else save substraction result as new remainder,
	sty remainder
	inc result	;and INCrement result cause divisor fit in 1 times
skip16	dex
	bne divloop16
	rts
	rts
	
	
	; ***********  Defining procedure : init16x8mul
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
mul16x8_num1Hi = $4c
mul16x8_num1 = $4e
mul16x8_num2 = $50
mul16x8_procedure
	lda #$00
	ldy #$00
	sty mul16x8_num1Hi  ; remove this line for 16*8=16bit multiply
	beq mul16x8_enterLoop
mul16x8_doAdd
	clc
	adc mul16x8_num1
	tax
	tya
	adc mul16x8_num1Hi
	tay
	txa
mul16x8_loop
	asl mul16x8_num1
	rol mul16x8_num1Hi
mul16x8_enterLoop  ; accumulating multiply entry point (enter with .A=lo, .Y=hi)
	lsr mul16x8_num2
	bcs mul16x8_doAdd
	bne mul16x8_loop
	rts
mul16x8_def_end
	rts
	
	
	; ***********  Defining procedure : init8x8div
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
div8x8_c = $4c
div8x8_d = $4e
div8x8_e = $50
	; Normal 8x8 bin div
div8x8_procedure
	lda #$00
	ldx #$07
	clc
div8x8_loop1 rol div8x8_d
	rol
	cmp div8x8_c
	bcc div8x8_loop2
	sbc div8x8_c
div8x8_loop2 dex
	bpl div8x8_loop1
	rol div8x8_d
	lda div8x8_d
	rts
div8x8_def_end
	rts
	
	
	; ***********  Defining procedure : init_decrunch
	;    Procedure type : User-defined procedure
	
init_decrunch
	jmp end_init_decrunch
;EXOD_LITERAL_SEQUENCES_NOT_USED = 1
; -------------------------------------------------------------------
; zero page addresses used
; -------------------------------------------------------------------
;exod_zp_len_lo = $a7

;exod_zp_src_lo  = $ae
;exod_zp_src_hi  = exod_zp_src_lo + 1

;exod_zp_bits_hi = $fc

;exod_zp_bitbuf  = $fd




exod_zp_len_lo = $47

exod_zp_src_lo  = $48
exod_zp_src_hi  = exod_zp_src_lo + 1

exod_zp_bits_hi = $4a

exod_zp_bitbuf  = $4b




exod_zp_dest_lo = exod_zp_bitbuf + 1	; dest addr lo
exod_zp_dest_hi = exod_zp_bitbuf + 2	; dest addr hi

exod_tabl_bi = exod_decrunch_table
exod_tabl_lo = exod_decrunch_table + 52
exod_tabl_hi = exod_decrunch_table + 104

; -------------------------------------------------------------------
; no code below this comment has to be modified in order to generate
; a working decruncher of this source file.
; However, you may want to relocate the tables last in the file to a
; more suitable address.
; -------------------------------------------------------------------

; -------------------------------------------------------------------
; jsr this label to decrunch, it will in turn init the tables and
; call the decruncher
; no constraints on register content, however the
; decimal flag has to be #0 (it almost always is, otherwise do a cld)
exod_decrunch:
; -------------------------------------------------------------------
; init zeropage, x and y regs. (12 bytes)
;
	ldy #0
	ldx #3
exod_init_zp:
	jsr exod_get_crunched_byte
        sta exod_zp_bitbuf-1,x
	dex
	bne exod_init_zp
; -------------------------------------------------------------------
; calculate tables (50 bytes)
; x and y must be #0 when entering
;
exod_nextone:
	inx
	tya
	and #$0f
	beq exod_shortcut		; starta på ny sekvens

	txa			; this clears reg a
	lsr			; and sets the carry flag
        ldx exod_tabl_bi-1,y
exod_rolle:
	rol
	rol exod_zp_bits_hi
	dex
	bpl exod_rolle		; c = 0 after this (rol exod_zp_bits_hi)

	adc exod_tabl_lo-1,y
	tax

	lda exod_zp_bits_hi
	adc exod_tabl_hi-1,y
exod_shortcut:
	sta exod_tabl_hi,y
	txa
	sta exod_tabl_lo,y

	ldx #4
	jsr exod_get_bits		; clears x-reg.
	sta exod_tabl_bi,y
	iny
	cpy #52
	bne exod_nextone
	ldy #0
	beq exod_begin
; -------------------------------------------------------------------
; get bits (29 bytes)
;
; args:
;   x = number of bits to get
; returns:
;   a = #bits_lo
;   x = #0
;   c = 0
;   z = 1
;   exod_zp_bits_hi = #bits_hi
; notes:
;   y is untouched
; -------------------------------------------------------------------
exod_get_bits:
	lda #$00
	sta exod_zp_bits_hi
	cpx #$01
	bcc exod_bits_done
exod_bits_next:
	lsr exod_zp_bitbuf
	bne exod_ok
	pha
exod_literal_get_byte:
	jsr exod_get_crunched_byte
	bcc exod_literal_byte_gotten
	ror
	sta exod_zp_bitbuf
	pla
exod_ok:
	rol
	rol exod_zp_bits_hi
	dex
	bne exod_bits_next
exod_bits_done:
	rts
; -------------------------------------------------------------------
; main copy loop (18(16) bytes)
;
exod_copy_next_hi:
	dex
	dec exod_zp_dest_hi
	dec exod_zp_src_hi
exod_copy_next:
	dey
	IFNCONST EXOD_LITERAL_SEQUENCES_NOT_USED
	bcc exod_literal_get_byte
	ENDIF
	lda (exod_zp_src_lo),y
exod_literal_byte_gotten:
	sta (exod_zp_dest_lo),y
exod_copy_start:
	tya
	bne exod_copy_next
exod_begin:
	txa
	bne exod_copy_next_hi
; -------------------------------------------------------------------
; decruncher entry point, needs calculated tables (21(13) bytes)
; x and y must be #0 when entering
;
	IFNCONST EXOD_LITERAL_SEQUENCES_NOT_USED
	inx
	jsr exod_get_bits
	tay
	bne exod_literal_start1
	ELSE
	dey
	ENDIF
exod_begin2:
	inx
	jsr exod_bits_next
	lsr
	iny
	bcc exod_begin2
	IFCONST EXOD_LITERAL_SEQUENCES_NOT_USED
	beq exod_literal_start
	ENDIF
	cpy #$11
	IFNCONST EXOD_LITERAL_SEQUENCES_NOT_USED
	bcc exod_sequence_start
	beq exod_bits_done
; -------------------------------------------------------------------
; literal sequence handling (13(2) bytes)
;
	ldx #$10
	jsr exod_get_bits
exod_literal_start1:
	sta <exod_zp_len_lo
	ldx <exod_zp_bits_hi
	ldy #0
	bcc exod_literal_start
exod_sequence_start:
	ELSE
	bcs exod_bits_done
	ENDIF
; -------------------------------------------------------------------
; calulate length of sequence (exod_zp_len) (11 bytes)
;
	ldx exod_tabl_bi - 1,y
	jsr exod_get_bits
	adc exod_tabl_lo - 1,y	; we have now calculated exod_zp_len_lo
	sta exod_zp_len_lo
; -------------------------------------------------------------------
; now do the hibyte of the sequence length calculation (6 bytes)
	lda exod_zp_bits_hi
	adc exod_tabl_hi - 1,y	; c = 0 after this.
	pha
; -------------------------------------------------------------------
; here we decide what offset table to use (20 bytes)
; x is 0 here
;
	bne exod_nots123
	ldy exod_zp_len_lo
	cpy #$04
	bcc exod_size123
exod_nots123:
	ldy #$03
exod_size123:
	ldx exod_tabl_bit - 1,y
	jsr exod_get_bits
	adc exod_tabl_off - 1,y	; c = 0 after this.
	tay			; 1 <= y <= 52 here
; -------------------------------------------------------------------
; Here we do the dest_lo -= len_lo subtraction to prepare exod_zp_dest
; but we do it backwards:	a - b == (b - a - 1) ^ ~0 (C-syntax)
; (16(16) bytes)
	lda exod_zp_len_lo
exod_literal_start:			; literal enters here with y = 0, c = 1
	sbc exod_zp_dest_lo
	bcc exod_noborrow
	dec exod_zp_dest_hi
exod_noborrow:
	eor #$ff
	sta exod_zp_dest_lo
	cpy #$01		; y < 1 then literal
	IFNCONST EXOD_LITERAL_SEQUENCES_NOT_USED
	bcc exod_pre_copy
	ELSE
	bcc exod_literal_get_byte
	ENDIF
; -------------------------------------------------------------------
; calulate absolute offset (exod_zp_src) (27 bytes)
;
	ldx exod_tabl_bi,y
	jsr exod_get_bits;
	adc exod_tabl_lo,y
	bcc exod_skipcarry
	inc exod_zp_bits_hi
	clc
exod_skipcarry:
	adc exod_zp_dest_lo
	sta exod_zp_src_lo
	lda exod_zp_bits_hi
	adc exod_tabl_hi,y
	adc exod_zp_dest_hi
	sta exod_zp_src_hi
; -------------------------------------------------------------------
; prepare for copy loop (8(6) bytes)
;
	pla
	tax
	IFNCONST EXOD_LITERAL_SEQUENCES_NOT_USED
	sec
exod_pre_copy:
	ldy <exod_zp_len_lo
	jmp exod_copy_start
	ELSE
	ldy <exod_zp_len_lo
	bcc exod_copy_start
	ENDIF
; -------------------------------------------------------------------
; two small static tables (6(6) bytes)
;
exod_tabl_bit:
	.byte 2,4,4
exod_tabl_off:
	.byte 48,32,16
; -------------------------------------------------------------------
; end of decruncher
; -------------------------------------------------------------------

; -------------------------------------------------------------------
; this 156 byte table area may be relocated. It may also be clobbered
; by other data between decrunches.
; -------------------------------------------------------------------
exod_decrunch_table:
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 0,0,0,0,0,0,0,0,0,0,0,0
; -------------------------------------------------------------------
; end of decruncher
; -------------------------------------------------------------------

exod_get_crunched_byte:
	lda opbase + 1
	bne nowrap
	dec opbase + 2
nowrap:	dec opbase + 1
	;; change the $ffff to point to the byte immediately following the last
	;; byte of the crunched file data (mem command)
opbase:	
	lda $FFFF
	rts
end_init_decrunch
	rts
	
	
	; ***********  Defining procedure : init_wedge
	;    Procedure type : User-defined procedure
	
IRQWedgeStartRegular

	; StartIRQ
	pha
	txa
	pha
	tya
	pha
	asl $d019
	; RasterIRQ : Hook a procedure
	; 8 bit binop
	; Add/sub where right value is constant number
	lda y
	clc
	adc #1
	 ; end add / sub var with constant
	
	sta $d012
	lda #00 ; lo ; 17
	sta $fffe
	lda #02 ; hi  ; 22
	sta $ffff
	; 
	; ****** Inline assembler section

	    tsx
    
	
	asl $d019
	cli
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop



	rti
IRQWedgeStartBad

	; StartIRQ
	pha
	txa
	pha
	tya
	pha
	asl $d019
	; RasterIRQ : Hook a procedure
	; 8 bit binop
	; Add/sub where right value is constant number
	lda y
	clc
	adc #2
	 ; end add / sub var with constant
	
	sta $d012
	lda #00
	sta $fffe
	lda #02
	sta $ffff
	; 
	; ****** Inline assembler section

	    tsx
    
	
	asl $d019
	cli
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	; 
	; ****** Inline assembler section
 bit $ea 
	

	rti
	rts
	
	
	; ***********  Defining procedure : initeightbitmul
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
multiplier = $4c
multiplier_a = $4e
multiply_eightbit
	cpx #$00
	beq mul_end
	dex
	stx $4e
	lsr
	sta multiplier
	lda #$00
	ldx #$08
mul_loop
	bcc mul_skip
mul_mod
	adc multiplier_a
mul_skip
	ror
	ror multiplier
	dex
	bne mul_loop
	ldx multiplier
	rts
mul_end
	txa
	rts
multiply_eightbit19035
	rts
	
	
	; ***********  Defining procedure : initmoveto
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
	jmp moveto24442
screenmemory =  $fe
screen_x = $4c
screen_y = $4e
SetScreenPosition
	sta screenmemory+1
	lda #0
	sta screenmemory
	ldy screen_y
	beq sydone
syloop
	clc
	adc #40
	bcc sskip
	inc screenmemory+1
sskip
	dey
	bne syloop
sydone
	ldx screen_x
	beq sxdone
	clc
	adc screen_x
	bcc sxdone
	inc screenmemory+1
sxdone
	sta screenmemory
	rts
moveto24442
	rts
	
	
	; ***********  Defining procedure : initprintstring
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
print_text = $4c
print_number_text .dc "    ",0
printstring
	ldy #0
printstringloop
	lda (print_text),y
	beq printstring_done
	cmp #64
	bcc printstring_skip
	sec
	sbc #64
printstring_skip
	sta (screenmemory),y
	iny
	dex
	cpx #0
	beq printstring_done
	jmp printstringloop
printstring_done
	rts
	
	
	; ***********  Defining procedure : initrandom
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
	; init random
init_random_call
	LDA #$FF
	STA $D40E
	STA $D40F
	LDA #$80
	STA $D412
	rts
upperRandom	dc.b	0
lowerRandom	dc.b	0
callRandom
	lda upperRandom
	sbc lowerRandom
	sta upperRandom
RandomLoop
	LDA $D41B ; get random value
	CMP upperRandom  ; compare to
	BCS RandomLoop   ; branch if value >
	ADC lowerRandom
	RTS
	rts
	
	
	; ***********  Defining procedure : initsinetable
	;    Procedure type : Built-in function
	;    Requires initialization : no
	
sine .byte 0 
	org sine +#255
value .word 0
delta .word 0
initsine_calculate
	ldy #$3f
	ldx #$00
initsin_a
	lda value
	clc
	adc delta
	sta value
	lda value+1
	adc delta+1
	sta value+1
	sta sine+$c0,x
	sta sine+$80,y
	eor #$ff
	sta sine+$40,x
	sta sine+$00,y
	lda delta
	adc #$10   ; this value adds up to the proper amplitude
	sta delta
	bcc initsin_b
	inc delta+1
initsin_b
	inx
	dey
	bpl initsin_a
	rts
	rts
	
	
	; ***********  Defining procedure : SetupScroll
	;    Procedure type : User-defined procedure
	
 ; Temp vars section
 ; Temp vars section ends
SetupScroll

	; Assigning single variable : k2
	
	sta k2
	; Assigning single variable : k
	lda #0
	sta k
for31527

	; Assigning single variable : ms_shift
	; Load Byte array
	; 8 bit binop
	; Add/sub where right value is constant number
	lda time
	clc
	adc k2
	 ; end add / sub var with constant
	
	tax
	lda sine,x
	
	sta ms_shift
	; Binary clause Simplified: NOTEQUALS
	lda dscroll
	; Compare with pure num / var optimization
	beq elsedoneblock4816
ConditionalTrueBlock10886

	; Assigning single variable : shifts
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub where right value is constant number
	lda #7
	sec
	sbc ms_shift
	 ; end add / sub var with constant
	
	and #7
	 ; end add / sub var with constant
	
	ldx k
	sta shifts,x

elsedoneblock4816
	; Assigning single variable : ms_shift
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda ms_shift
	
	lsr
	lsr
	lsr
	
	sta ms_shift
	; Assigning single variable : shifts2
	ldx k
	sta shifts2,x
	; Binary clause Simplified: EQUALS
	lda k
	; Compare with pure num / var optimization
	cmp #1
	bne elsedoneblock14312
ConditionalTrueBlock9131
	; Assigning single variable : shifts
	; 8 bit binop
	; Add/sub where right value is constant number
	lda #7
	sec
	sbc dscroll
	 ; end add / sub var with constant
	
	ldx k
	sta shifts,x
elsedoneblock14312
	; Assigning single variable : k2
	; Optimizer: a = a +/- b
	lda k2
	clc
	adc #44
	sta k2

	inc k
	lda #4
	cmp k
	bne for31527
forLoopDone8343

	rts
	
	
	; ***********  Defining procedure : PrintWaves
	;    Procedure type : User-defined procedure
	
PrintWaves

	lda #0
	sta screen_x
	lda #14
	sta screen_y
	lda #4
	jsr SetScreenPosition
	; Assigning single variable : p1
	lda screenmemory
	ldx screenmemory+1
	sta p1
	stx p1+1
	lda #40
	clc
	adc p1
	bcc incscreenx19548
	inc p1 +1
incscreenx19548
	sta p1
	; Assigning single variable : a
	lda #0
	sta a
	; Assigning single variable : b
	lda #40
	sta b
	; Assigning single variable : ms_shift
	; Load Byte array
	ldx #0
	lda shifts2,x
	
	sta ms_shift
	jsr PrintWave
	; Assigning single variable : ms_shift
	; Load Byte array
	ldx #2
	lda shifts2,x
	
	sta ms_shift
	lda #0
	sta screen_x
	lda #20
	sta screen_y
	lda #4
	jsr SetScreenPosition
	; Assigning single variable : p1
	lda screenmemory
	ldx screenmemory+1
	sta p1
	stx p1+1
	lda #40
	clc
	adc p1
	bcc incscreenx14499
	inc p1 +1
incscreenx14499
	sta p1
	jsr PrintWave

	rts
	
	
	; ***********  Defining procedure : RenderCredzChar
	;    Procedure type : User-defined procedure
	
RenderCredzChar

	; Assigning single variable : k
	; Load pointer array
	ldy #0
	lda (tp),y
	
	sta k
	; Binary clause Simplified: EQUALS
	; Compare with pure num / var optimization
	bne elsedoneblock28651
ConditionalTrueBlock654

	; Assigning single variable : tp
	lda #<text
	ldx #>text
	sta tp
	stx tp+1
	; Assigning single variable : scroll
	lda #0
	sta scroll
	rts

elsedoneblock28651
	; Binary clause Simplified: EQUALS
	lda k
	; Compare with pure num / var optimization
	cmp #128
	bne elsedoneblock25451
ConditionalTrueBlock4696

	; Assigning single variable : dy
	; Load pointer array
	ldy #1
	lda (tp),y
	
	sta dy
	lda #2
	clc
	adc tp
	bcc incscreenx20735
	inc tp +1
incscreenx20735
	sta tp
	rts

elsedoneblock25451
	; Assigning single variable : k
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda k
	
	asl
	
	sta k
	; 
	; ****** Inline assembler section

			ldy k
			lda 10752,y
			sta zp
			iny
			lda 10752,y
			sta zp+1

		
	
	; Assigning single variable : screenmemory
	lda #167
	ldx #6
	sta screenmemory
	stx screenmemory+1
	; Assigning single variable : idx
	lda #1
	sta idx
	; Assigning single variable : l
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda scroll
	
	asl
	
	sta l
	; Assigning single variable : m
	; 8 bit binop
	; Add/sub where right value is constant number
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda scroll
	
	asl
	
	clc
	adc #2
	 ; end add / sub var with constant
	
	sta m
	; Assigning single variable : y
	lda #0
	sta y
for13131
forLoopFix16221

	; Assigning single variable : x
	lda l
	sta x
for460
forLoopFix18132

	; Assigning single variable : k
	; 8 bit binop
	; Add/sub where right value is constant number
	lda #7
	sec
	sbc x
	 ; end add / sub var with constant
	
	tax
	lda #1
shiftbit19275
	cpx #0
	beq shiftbitdone8609
	asl
	dex
	jmp shiftbit19275
shiftbitdone8609
bitmask_var8139 = $54
	sta bitmask_var8139
	; Load pointer array
	ldy y
	lda (zp),y
	
	and bitmask_var8139
	cmp bitmask_var8139
	bne getbit_false28446
	lda #1
	jmp getbit_done30710
getbit_false28446
	lda #0
getbit_done30710
	
	sta k
	; Assigning single variable : k
	; 8 bit binop
	; Add/sub where right value is constant number
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	; 8 bit binop
	; Add/sub where right value is constant number
	lda #6
	sec
	sbc x
	 ; end add / sub var with constant
	
	tax
	lda #1
shiftbit11059
	cpx #0
	beq shiftbitdone23981
	asl
	dex
	jmp shiftbit11059
shiftbitdone23981
bitmask_var30730 = $54
	sta bitmask_var30730
	; Load pointer array
	ldy y
	lda (zp),y
	
	and bitmask_var30730
	cmp bitmask_var30730
	bne getbit_false2873
	lda #1
	jmp getbit_done6872
getbit_false2873
	lda #0
getbit_done6872
	
	asl
	
	clc
	adc k
	 ; end add / sub var with constant
	
	sta k
	; Assigning single variable : k
	; 8 bit binop
	; Add/sub where right value is constant number
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	; 8 bit binop
	; Add/sub where right value is constant number
	lda #6
	sec
	sbc x
	 ; end add / sub var with constant
	
	tax
	lda #1
shiftbit25545
	cpx #0
	beq shiftbitdone14887
	asl
	dex
	jmp shiftbit25545
shiftbitdone14887
bitmask_var31709 = $54
	sta bitmask_var31709
	; Load pointer array
	; LDA stuff
	; 8 bit binop
	; Add/sub where right value is constant number
	lda y
	clc
	adc #1
	 ; end add / sub var with constant
	
	tay
	lda (zp),y
	
	and bitmask_var31709
	cmp bitmask_var31709
	bne getbit_false15940
	lda #1
	jmp getbit_done27543
getbit_false15940
	lda #0
getbit_done27543
	
	asl
	asl
	
	clc
	adc k
	 ; end add / sub var with constant
	
	sta k
	; Assigning single variable : k
	; 8 bit binop
	; Add/sub where right value is constant number
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	; 8 bit binop
	; Add/sub where right value is constant number
	lda #7
	sec
	sbc x
	 ; end add / sub var with constant
	
	tax
	lda #1
shiftbit12527
	cpx #0
	beq shiftbitdone27677
	asl
	dex
	jmp shiftbit12527
shiftbitdone27677
bitmask_var9456 = $54
	sta bitmask_var9456
	; Load pointer array
	; LDA stuff
	; 8 bit binop
	; Add/sub where right value is constant number
	lda y
	clc
	adc #1
	 ; end add / sub var with constant
	
	tay
	lda (zp),y
	
	and bitmask_var9456
	cmp bitmask_var9456
	bne getbit_false9014
	lda #1
	jmp getbit_done30446
getbit_false9014
	lda #0
getbit_done30446
	
	asl
	asl
	asl
	
	clc
	adc k
	 ; end add / sub var with constant
	
	sta k
	; Binary clause Simplified: EQUALS
	; Load pointer array
	ldy #0
	lda (tp),y
	
	; Compare with pure num / var optimization
	cmp #32
	bne elsedoneblock32446
ConditionalTrueBlock988
	; Assigning single variable : k
	lda #0
	sta k
elsedoneblock32446
	; Assigning single variable : screenmemory
	; Load Byte array
	ldx k
	lda fontTable,x
	
	ldy #0
	sta (screenmemory),y

	clc
	lda x
	adc #2
	sta x
	lda m
	cmp x
	beq forLoopDone26956
	jmp for460
forLoopDone26956
	lda #40
	clc
	adc screenmemory
	bcc incscreenx13406
	inc screenmemory +1
incscreenx13406
	sta screenmemory

	clc
	lda y
	adc #2
	sta y
	lda #8
	cmp y
	beq forLoopDone11716
	jmp for13131
forLoopDone11716
	inc scroll
	; Binary clause Simplified: EQUALS
	lda scroll
	; Compare with pure num / var optimization
	cmp #4
	bne elsedoneblock14224
ConditionalTrueBlock1509

	lda #1
	clc
	adc tp
	bcc incscreenx11763
	inc tp +1
incscreenx11763
	sta tp
	; Assigning single variable : scroll
	lda #0
	sta scroll

elsedoneblock14224
	; Assigning single variable : dy
	lda #0
	sta dy

	rts
	
	
	; ***********  Defining procedure : SetupFontTab
	;    Procedure type : User-defined procedure
	
SetupFontTab

	; Assigning single variable : p1
	lda #0
	ldx #42
	sta p1
	stx p1+1
	; Assigning single variable : i
	sta i
for24593
forLoopFix10418

	; Assigning single variable : k
	lda i
	sta k
	; Binary clause Simplified: GREATER
	; Compare with pure num / var optimization
	cmp #64
	bcc elsedoneblock10908
ConditionalTrueBlock24737
	; Assigning single variable : k
	; Optimizer: a = a +/- b
	lda k
	sec
	sbc #64
	sta k
elsedoneblock10908
	; Assigning single variable : zp
	lda #0
	ldx #32
	sta zp
	stx zp+1
	; Binary clause Simplified: GREATER
	lda k
	; Compare with pure num / var optimization
	cmp #31
	bcc elsedoneblock17698
ConditionalTrueBlock1512

	; Assigning single variable : k
	; Optimizer: a = a +/- b
	lda k
	sec
	sbc #31
	sta k
	lda #248
	
	clc
	adc zp
	bcc incscreenx17549
	inc zp +1
incscreenx17549
	sta zp

elsedoneblock17698
	; Binary clause Simplified: NOTEQUALS
	lda k
	; Compare with pure num / var optimization
	beq elsedoneblock2904
ConditionalTrueBlock343
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda k
	
	asl
	asl
	asl
	
	clc
	adc zp
	bcc incscreenx10904
	inc zp +1
incscreenx10904
	sta zp
elsedoneblock2904
	; Assigning single variable : k
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda i
	
	asl
	
	sta k
	; 
	; ****** Inline assembler section

			ldy k
	
			lda zp
			sta (p1),y
			lda zp+1
			iny
			sta (p1),y

	

		
	

	inc i
	lda #128
	cmp i
	beq forLoopDone24385
	jmp for24593
forLoopDone24385

	rts
	
	
	; ***********  Defining procedure : SetupCopyText
	;    Procedure type : User-defined procedure
	
SetupCopyText

	; Assigning single variable : p3
	lda #0
	ldx #36
	sta p3
	stx p3+1
	; Assigning single variable : p4
	lda #128
	ldx #36
	sta p4
	stx p4+1
	; Assigning single variable : time2
	inc time2
	; Assigning single variable : sx
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub right value is variable/expression
	; Right is PURE NUMERIC
	; 8 bit div
	; Load Byte array
	; 8 bit binop
	; Add/sub where right value is constant number
	lda time2
	clc
	adc #32
	 ; end add / sub var with constant
	
	tax
	lda sine,x
	
	sta div8x8_d
	
	; Load right hand side
	lda #12
	sta div8x8_c
	
	jsr div8x8_procedure
	
rightvarAddSub_var19031 = $54
	sta rightvarAddSub_var19031
	lda #0
	sec
	sbc rightvarAddSub_var19031
	
	clc
	adc #4
	 ; end add / sub var with constant
	
	sta sx
	; Binary clause Simplified: GREATER
	lda time2
	; Compare with pure num / var optimization
	cmp #253
	bcc elsedoneblock27111
ConditionalTrueBlock32379

while29188
	; Binary clause Simplified: NOTEQUALS
	; Load pointer array
	ldy #0
	lda (tp2),y
	
	; Compare with pure num / var optimization
	cmp #255
	beq elsedoneblock10963
ConditionalTrueBlock19289
	lda #1
	clc
	adc tp2
	bcc incscreenx26307
	inc tp2 +1
incscreenx26307
	sta tp2
	jmp while29188
elsedoneblock10963
	lda #1
	clc
	adc tp2
	bcc incscreenx6442
	inc tp2 +1
incscreenx6442
	sta tp2
	; Binary clause Simplified: EQUALS
	; Load pointer array
	ldy #0
	lda (tp2),y
	
	; Compare with pure num / var optimization
	bne elsedoneblock5016
ConditionalTrueBlock6249
	; Assigning single variable : tp2
	lda #<waves
	ldx #>waves
	sta tp2
	stx tp2+1
elsedoneblock5016
	; Assigning single variable : time2
	lda #0
	sta time2

elsedoneblock27111
	; Assigning single variable : cc
	lda #0
	sta cc
	; Assigning single variable : tt
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda time2
	
	asl
	asl
	
	sta tt

	rts
	
	
	; ***********  Defining procedure : CopyText
	;    Procedure type : User-defined procedure
	
CopyText

	; Assigning single variable : i_
	lda a
	sta i_
for15204
forLoopFix15184

	; Assigning single variable : k_
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	; Load pointer array
	ldy i_
	lda (tp2),y
	
	asl
	
	sta k_
	; 
	; ****** Inline assembler section

			
			ldy k_
			lda 10752,y
			sta zp2
			iny
			lda 10752,y
			sta zp2+1

		
	
	; 
	; ****** Inline assembler section

			ldy #0
			lda #0
ll1:
			sta (p3),y
			sta (p4),y
			iny
			cpy #8
			bne ll1	
		
	
	; Assigning single variable : k2_
	; 8 bit binop
	; Add/sub where right value is constant number
	; Load Byte array
	; 8 bit binop
	; Add/sub where right value is constant number
	lda tt
	clc
	adc cc
	 ; end add / sub var with constant
	
	tax
	lda sine2,x
	
	clc
	adc sx
	 ; end add / sub var with constant
	
	sta k2_
	; Binary clause Simplified: NOTEQUALS
	; Load pointer array
	ldy i_
	lda (tp2),y
	
	; Compare with pure num / var optimization
	cmp #32
	beq elsedoneblock21809
ConditionalTrueBlock16960
	; 
	; ****** Inline assembler section


				ldy #0
ppqq:			sty p1
				
				
;				ldy j_
				lda (zp2),y
				sta zp

				tya
				clc
				adc k2_
				tax
				lda tab,x
				tay
				lda zp
				sta (p3),y

				ldy p1
				iny
				cpy #7
				bne ppqq
				
			
	
elsedoneblock21809
	; Assigning single variable : cc
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub where right value is constant number
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	; Load Byte array
	ldx time
	lda sine,x
	
	lsr
	lsr
	lsr
	
	clc
	adc cc
	 ; end add / sub var with constant
	
	clc
	adc #16
	 ; end add / sub var with constant
	
	sta cc
	lda #8
	clc
	adc p3
	bcc incscreenx24551
	inc p3 +1
incscreenx24551
	sta p3
	lda #8
	clc
	adc p4
	bcc incscreenx5225
	inc p4 +1
incscreenx5225
	sta p4

	inc i_
	lda b
	cmp i_
	beq forLoopDone14460
	jmp for15204
forLoopDone14460
	; Poke
	; Optimization: shift is zero
	lda #0
	sta 9470

	rts
	
	
	; ***********  Defining procedure : RenderStars
	;    Procedure type : User-defined procedure
	
RenderStars

	lda #0
	sta screen_x
	lda #7
	sta screen_y
	lda #216
	jsr SetScreenPosition
	; Assigning single variable : p1
	lda screenmemory
	ldx screenmemory+1
	sta p1
	stx p1+1
	lda #0
	sta screen_x
	lda #7
	sta screen_y
	lda #4
	jsr SetScreenPosition
	; Assigning single variable : k
	lda #0
	sta k
	; Assigning single variable : dsx
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda time
	
	lsr
	lsr
	
	sta dsx
	; Assigning single variable : i
	lda a
	sta i
for10679
forLoopFix2039

	; Assigning single variable : j
	lda #0
	sta j
for2232
forLoopFix9337

	; Assigning single variable : star_dx
	; Optimizer: a = a +/- b
	; Load Byte array
	ldx k
	lda star_dx,x
	sec
	; Load Byte array
	ldx k
	sbc star_ddx,x
	
	ldx k
	sta star_dx,x
	; Binary clause: GREATER
	; Load Byte array
	ldx k
	lda star_dx,x
	
	; Compare with pure num / var optimization
	cmp #127
	bcc binaryclausefailed8402
	lda #1; success
	jmp binaryclausefinished27853
binaryclausefailed8402
	lda #0 ; failed state
binaryclausefinished27853
	cmp #1
	beq ConditionalTrueBlock337
	jmp elsedoneblock12686
ConditionalTrueBlock337

	; Assigning single variable : star_dx
	; Optimizer: a = a +/- b
	; Load Byte array
	ldx k
	lda star_dx,x
	clc
	adc #8
	ldx k
	sta star_dx,x
	; Assigning single variable : m
	; Load Byte array
	ldx k
	lda star_x,x
	
	sta m
	; Assigning single variable : l
	; Load pointer array
	ldy m
	lda (screenmemory),y
	
	sta l
	; Binary clause: GREATER
	; Compare with pure num / var optimization
	cmp #176
	bcc binaryclausefailed18480
	lda #1; success
	jmp binaryclausefinished23976
binaryclausefailed18480
	lda #0 ; failed state
binaryclausefinished23976
logical_class_temp_var13801 = $54
	sta logical_class_temp_var13801
	; Binary clause: LESS
	lda l
	; Compare with pure num / var optimization
	cmp #184
	bcs binaryclausefailed857
	lda #1; success
	jmp binaryclausefinished30693
binaryclausefailed857
	lda #0 ; failed state
binaryclausefinished30693
	and logical_class_temp_var13801
	cmp #1
	beq ConditionalTrueBlock12178
	jmp elsedoneblock14474
ConditionalTrueBlock12178
	; Assigning single variable : screenmemory
	lda #32
	ldy m
	sta (screenmemory),y
elsedoneblock14474
	ldx k ; optimized, look out for bugs
	dec star_x,x
	; Binary clause Simplified: GREATER
	; Load Byte array
	ldx k
	lda star_x,x
	
	; Compare with pure num / var optimization
	cmp #128
	bcc elsedoneblock11122
ConditionalTrueBlock17708

	; Assigning single variable : star_x
	lda #39
	ldx k
	sta star_x,x
	; Assigning single variable : star_ddx
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub where right value is constant number
	lda time
	and #3
	 ; end add / sub var with constant
	
	clc
	adc #1
	 ; end add / sub var with constant
	
	ldx k
	sta star_ddx,x

elsedoneblock11122

elsedoneblock12686
	; Assigning single variable : m
	; Load Byte array
	ldx k
	lda star_x,x
	
	sta m
	; Assigning single variable : l
	; Load pointer array
	ldy m
	lda (screenmemory),y
	
	sta l
	; Binary clause Simplified: GREATER
	; Compare with pure num / var optimization
	cmp #176
	bcc elsedoneblock21897
ConditionalTrueBlock32672
	; Binary clause Simplified: LESS
	lda l
	; Compare with pure num / var optimization
	cmp #184
	bcs elsedoneblock10993
ConditionalTrueBlock9810
	; Assigning single variable : l
	lda #32
	sta l
elsedoneblock10993
elsedoneblock21897
	; Binary clause Simplified: EQUALS
	lda l
	; Compare with pure num / var optimization
	cmp #32
	bne elsedoneblock20643
ConditionalTrueBlock8294

	; Assigning single variable : p1
	; Load Byte array
	; 8 bit binop
	; Add/sub where right value is constant number
	lda dsx
	and #15
	 ; end add / sub var with constant
	
	tax
	lda fadeBlue,x
	
	ldy m
	sta (p1),y
	; Assigning single variable : screenmemory
	; 8 bit binop
	; Add/sub where right value is constant number
	lda #176
	clc
	; Load Byte array
	ldx k
	adc star_dx,x
	
	 ; end add / sub var with constant
	
	ldy m
	sta (screenmemory),y

elsedoneblock20643
	inc k
	inc dsx

	inc j
	lda #2
	cmp j
	beq forLoopDone19966
	jmp for2232
forLoopDone19966
	lda #40
	clc
	adc screenmemory
	bcc incscreenx21610
	inc screenmemory +1
incscreenx21610
	sta screenmemory
	lda #40
	clc
	adc p1
	bcc incscreenx18129
	inc p1 +1
incscreenx18129
	sta p1

	inc i
	lda b
	cmp i
	beq forLoopDone3446
	jmp for10679
forLoopDone3446

	rts
	
	
	; ***********  Defining procedure : RasterTop
	;    Procedure type : User-defined procedure
	
RasterTop

	; StartIRQ
	pha
	txa
	pha
	tya
	pha
	asl $d019
	; Regularcolor mode
	lda $d016
	and #%11101111
	sta $d016
	; Assigning memory location (poke replacement)
	; Assigning single variable : $d020
	lda bgcol
	sta $d020
	; Assigning memory location (poke replacement)
	; Assigning single variable : $d021
	sta $d021
	; Assigning single variable : i
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	; Load Byte array
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda time
	
	asl
	asl
	
	tax
	lda sine,x
	
	lsr
	lsr
	lsr
	lsr
	lsr
	
	sta i
	lda $d016  
	and #$F8
	ora i
	sta $d016
	inc time
	; Assigning single variable : dscroll
	; Optimizer: a = a +/- b
	lda dscroll
	clc
	adc #2
	sta dscroll
	; Binary clause: EQUALS
	; Compare with pure num / var optimization
	cmp #8
	bne binaryclausefailed13992
	lda #1; success
	jmp binaryclausefinished5049
binaryclausefailed13992
	lda #0 ; failed state
binaryclausefinished5049
	cmp #1
	beq ConditionalTrueBlock16689
	jmp elsedoneblock22836
ConditionalTrueBlock16689

	; Assigning single variable : zp
	lda #128
	ldx #6
	sta zp
	stx zp+1
	; Assigning single variable : p1
	lda #129
	ldx #6
	sta p1
	stx p1+1
	; Assigning single variable : i
	lda #0
	sta i
for16499

	; memcpy
	ldy #0
memcpy16311
	lda (p1),y
	sta (zp),y
	iny
	cpy #39
	bne memcpy16311
	lda #40
	clc
	adc zp
	bcc incscreenx6240
	inc zp +1
incscreenx6240
	sta zp
	lda #40
	clc
	adc p1
	bcc incscreenx5623
	inc p1 +1
incscreenx5623
	sta p1

	inc i
	lda #4
	cmp i
	bne for16499
forLoopDone8684
	; Assigning single variable : zp
	lda #128
	ldx #218
	sta zp
	stx zp+1
	; Assigning single variable : p1
	lda #129
	ldx #218
	sta p1
	stx p1+1
	; Assigning single variable : i
	lda #0
	sta i
for22065

	; Assigning single variable : j
	; Load pointer array
	ldy #0
	lda (zp),y
	
	sta j
	; memcpy
	ldy #0
memcpy21049
	lda (p1),y
	sta (zp),y
	iny
	cpy #39
	bne memcpy21049
	; Assigning single variable : zp
	lda j
	ldy #39
	sta (zp),y
	lda #40
	clc
	adc zp
	bcc incscreenx16704
	inc zp +1
incscreenx16704
	sta zp
	lda #40
	clc
	adc p1
	bcc incscreenx8001
	inc p1 +1
incscreenx8001
	sta p1

	inc i
	lda #4
	cmp i
	bne for22065
forLoopDone27167
	; Assigning single variable : dscroll
	lda #0
	sta dscroll

elsedoneblock22836
	jsr SetupScroll
	; Binary clause Simplified: NOTEQUALS
	lda dscroll
	; Compare with pure num / var optimization
	beq elsedoneblock2208
ConditionalTrueBlock16385

	jsr PrintWaves
	; Assigning single variable : a
	lda #0
	sta a
	; Assigning single variable : b
	lda #7
	sta b
	jsr RenderStars

elsedoneblock2208
	; Assigning single variable : y
	lda #160
	
	sta y
	; Assigning single variable : current
	lda #0
	sta current
	; Assigning single variable : idx
	sta idx
	; RasterIRQ : Hook a procedure
	lda y
	sta $d012
	lda #<RasterBar
	sta $fffe
	lda #>RasterBar
	sta $ffff
	; Assigning single variable : i
	lda time
	sta i
	; Hide x border
	lda $D016
	and #$f7  ; change bit 4
	sta $D016
	; Assigning single variable : a
	lda #5
	sta a
	; Assigning single variable : b
	lda #6
	sta b
	; Binary clause Simplified: EQUALS
	; Keypressed
	lda #$FF  ; CIA#1 port A = outputs 
	sta $dc02             
	lda #%00000000  ; CIA#1 port B = inputs
	sta $dc03             
	lda #%1111111
	sta  $dc00
	lda $dc01
	and #%10000
	cmp #%10000
	bne keypressedA20394
	lda #0
	jmp keypressedB29909
keypressedA20394
	lda #1
keypressedB29909
	
	; Compare with pure num / var optimization
	cmp #1
	bne elsedoneblock18942
ConditionalTrueBlock18414

	; Set Memory Config
	lda $01
	and #%11111000
	ora #%111
	sta $01
	lda $D011
	and #%01101111
	sta $D011
	; 
	; ****** Inline assembler section
 jmp $FCE2 
	

elsedoneblock18942
	; CloseIRQ
	pla
	tay
	pla
	tax
	pla

	rti
	
	
	; ***********  Defining procedure : RasterBar
	;    Procedure type : User-defined procedure
	
RasterBar

	; StartIRQ
	pha
	txa
	pha
	tya
	pha
	asl $d019
	; Wait
	ldx #17
	dex
	bne *-1
	; Assigning memory location (poke replacement)
	; Assigning single variable : $d020
	; Load Byte array
	ldx idx
	lda colorsRedhues,x
	
	sta $d020
	; Assigning memory location (poke replacement)
	; Assigning single variable : $d021
	sta $d021
	inc idx
	lda $d016  
	and #$F8
	; Load Byte array
	ldx current
	ora shifts,x
	
	sta $d016
	; Assigning single variable : y
	; Optimizer: a = a +/- b
	lda y
	clc
	adc #16
	sta y
	; Binary clause Simplified: EQUALS
	lda idx
	; Compare with pure num / var optimization
	cmp #2
	bne elsedoneblock23121
ConditionalTrueBlock1632
	; Assigning single variable : y
	; Optimizer: a = a +/- b
	lda y
	clc
	adc #16
	sta y
elsedoneblock23121
	inc current
	; RasterIRQ : Hook a procedure
	lda y
	sta $d012
	lda #<RasterBar
	sta $fffe
	lda #>RasterBar
	sta $ffff
	; Binary clause Simplified: EQUALS
	lda idx
	; Compare with pure num / var optimization
	cmp #4
	bne elsedoneblock18540
ConditionalTrueBlock19233

	; RasterIRQ : Hook a procedure
	lda #0
	sta $d012
	lda #<RasterTop
	sta $fffe
	lda #>RasterTop
	sta $ffff
	; Binary clause Simplified: EQUALS
	lda dscroll
	; Compare with pure num / var optimization
	bne elseblock29732
ConditionalTrueBlock11740

	jsr RenderCredzChar

	jmp elsedoneblock17177
elseblock29732

	; Assigning single variable : a
	lda #0
	sta a
	; Assigning single variable : b
	lda #8
	sta b
	jsr SetupCopyText
	jsr CopyText

elsedoneblock17177

elsedoneblock18540
	; Binary clause Simplified: EQUALS
	lda idx
	; Compare with pure num / var optimization
	cmp #2
	bne elsedoneblock14843
ConditionalTrueBlock31702

	jsr $2b03
	jsr MoveRestSprites

elsedoneblock14843
	; Binary clause Simplified: EQUALS
	lda idx
	; Compare with pure num / var optimization
	cmp #1
	bne elsedoneblock20016
ConditionalTrueBlock7933
	jsr MoveSprites
elsedoneblock20016
	; CloseIRQ
	pla
	tay
	pla
	tax
	pla

	rti
	
	
	; ***********  Defining procedure : SetupSine2
	;    Procedure type : User-defined procedure
	
SetupSine2

	; Assigning single variable : i
	lda #0
	sta i
for20748
	; Assigning single variable : sine2
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	; Load Byte array
	ldx i
	lda sine,x
	
	lsr
	lsr
	lsr
	lsr
	lsr
	
	ldx i
	sta sine2,x
	inc i
	lda #0
	cmp i
	bne for20748
forLoopDone6423
	lda #254
	ldx #0
fill14681
	sta tab,x
	inx
	cpx #0
	bne fill14681
	; Assigning single variable : i
	lda #0
	sta i
for12622

	; Binary clause Simplified: LESS
	lda i
	; Compare with pure num / var optimization
	cmp #16
	bcs elsedoneblock11682
ConditionalTrueBlock28504
	; Assigning single variable : tab
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub right value is variable/expression
	lda #128
	
rightvarAddSub_var15347 = $54
	sta rightvarAddSub_var15347
	lda i
	clc
	adc rightvarAddSub_var15347
	
	sec
	sbc #8
	 ; end add / sub var with constant
	
	ldx i
	sta tab,x
elsedoneblock11682
	; Binary clause Simplified: LESS
	lda i
	; Compare with pure num / var optimization
	cmp #8
	bcs elsedoneblock21813
ConditionalTrueBlock31960
	; Assigning single variable : tab
	lda i
	ldx i
	sta tab,x
elsedoneblock21813

	inc i
	lda #32
	cmp i
	bne for12622
forLoopDone29870

	rts
	
	
	; ***********  Defining procedure : InitStars
	;    Procedure type : User-defined procedure
	
InitStars

	; Assigning single variable : i
	lda #0
	sta i
for27338

	lda #0
	sta lowerRandom
	lda #160
	sta upperRandom
	jsr callRandom
	sta j
	; Assigning single variable : star_x
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	
	lsr
	lsr
	
	ldx i
	sta star_x,x
	lda #0
	sta lowerRandom
	lda #255
	sta upperRandom
	jsr callRandom
	sta j
	; Assigning single variable : star_dx
	; 8 bit binop
	; Add/sub where right value is constant number
	and #7
	 ; end add / sub var with constant
	
	ldx i
	sta star_dx,x
	lda #0
	sta lowerRandom
	lda #255
	sta upperRandom
	jsr callRandom
	sta j
	; Assigning single variable : star_ddx
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub where right value is constant number
	and #3
	 ; end add / sub var with constant
	
	clc
	adc #1
	 ; end add / sub var with constant
	
	ldx i
	sta star_ddx,x

	inc i
	lda #24
	cmp i
	bne for27338
forLoopDone21367
	; Assigning single variable : zp
	lda #128
	ldx #37
	sta zp
	stx zp+1
	; Assigning single variable : i
	lda #0
	sta i
for25677

	lda #0
	ldy #0
fill5425
	sta (zp),y
	iny
	cpy #8
	bne fill5425
	; 8 bit binop
	; Add/sub where right value is constant number
	lda #7
	sec
	sbc i
	 ; end add / sub var with constant
	
	tax
	lda #1
shiftbit18962
	cpx #0
	beq shiftbitdone13230
	asl
	dex
	jmp shiftbit18962
shiftbitdone13230
bitmask_var18704 = $54
	sta bitmask_var18704
	; Load pointer array
	ldy #3
	lda (zp),y
	
	ora bitmask_var18704
	; Load pointer array
	ldy #3
	sta (zp),y
	
	; 8 bit binop
	; Add/sub where right value is constant number
	lda #7
	sec
	sbc i
	 ; end add / sub var with constant
	
	tax
	lda #1
shiftbit4473
	cpx #0
	beq shiftbitdone24837
	asl
	dex
	jmp shiftbit4473
shiftbitdone24837
bitmask_var28861 = $54
	sta bitmask_var28861
	; Load pointer array
	ldy #4
	lda (zp),y
	
	ora bitmask_var28861
	; Load pointer array
	ldy #4
	sta (zp),y
	
	lda #8
	clc
	adc zp
	bcc incscreenx7278
	inc zp +1
incscreenx7278
	sta zp

	inc i
	lda #8
	cmp i
	bne for25677
forLoopDone24896

	rts
	
	
	; ***********  Defining procedure : MoveSprites
	;    Procedure type : User-defined procedure
	
MoveSprites

	; Assigning single variable : i
	; 8 bit binop
	; Add/sub where right value is constant number
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	; Load Byte array
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda time
	
	asl
	
	tax
	lda sine,x
	
	lsr
	lsr
	
	clc
	adc #40
	 ; end add / sub var with constant
	
	sta i
	; Assigning single variable : int
	ldy #0
	lda i
	sta int
	sty int+1
	; Assigning single variable : j
	lda #0
	sta j
	; Assigning single variable : i
	sta i
for17363

	; Assigning single variable : int
	ldy #0
	; WORD optimization: a=a+b
	lda int+0
	
	clc
	adc #24
	bcc WordAdd22871
	inc int+1
WordAdd22871
	sta int+0
	; Poke
	; integer assignment NodeVar
	ldy int+1 ; next one ; optimized, look out for bugs
	lda int
	ldx j
	sta $d000,x
	; Assigning single variable : j
	; Optimizer: a = a +/- b
	lda j
	clc
	adc #2
	sta j

	inc i
	lda #5
	cmp i
	bne for17363
forLoopDone15598

	rts
	
	
	; ***********  Defining procedure : MoveRestSprites
	;    Procedure type : User-defined procedure
	
MoveRestSprites

	; Assigning single variable : i
	lda #5
	sta i
for3000

	; Assigning single variable : int
	ldy #0
	; WORD optimization: a=a+b
	lda int+0
	
	clc
	adc #24
	bcc WordAdd229
	inc int+1
WordAdd229
	sta int+0
	; Setting sprite position
	lda i
	pha
	tax
	lda #1
shiftbit14275
	cpx #0
	beq shiftbitdone6133
	asl
	dex
	jmp shiftbit14275
shiftbitdone6133
bitmask_var27116 = $54
	sta bitmask_var27116
	pla
	asl
	tax
	; integer assignment NodeVar
	ldy int+1 ; next one ; optimized, look out for bugs
	lda int
	sta $D000,x
	; integer assignment NodeVar
	ldy int+1 ; next one ; optimized, look out for bugs
	lda int+1
	beq spritepos8091
	lda $D010
	ora bitmask_var27116
	sta $D010
	jmp spriteposcontinue10953
spritepos8091
	lda #$FF
	eor bitmask_var27116
	sta bitmask_var27116
	lda $D010
	and bitmask_var27116
	sta $D010
spriteposcontinue10953
	inx
	txa
	tay
	lda #210
	sta $D000,y

	inc i
	lda #8
	cmp i
	bne for3000
forLoopDone22981

	rts
	
	
	; ***********  Defining procedure : InitSprites
	;    Procedure type : User-defined procedure
	
InitSprites

	; Assigning memory location (poke replacement)
	; Assigning single variable : $d015
	lda #255
	sta $d015
	; Assigning memory location (poke replacement)
	; Assigning single variable : $d01c
	sta $d01c
	; Assigning memory location (poke replacement)
	; Assigning single variable : $d017
	sta $d017
	; Assigning single variable : $d025
	lda #6
	sta $d025+0
	; Assigning single variable : $d025
	lda #3
	sta $d025+1
	; Assigning single variable : i
	lda #0
	sta i
for2671
forLoopFix22445

	; Assigning single variable : int
	ldy #0
	; Right is PURE NUMERIC
	; 16 bit mul or div
	; Mul 16x8 setup
	
	lda i
	
	sta mul16x8_num1
	lda #0
	sta mul16x8_num1Hi
	
	lda #24
	
	sta mul16x8_num2
	jsr mul16x8_procedure
	
	sta int
	sty int+1
	; Assigning single variable : int
	ldy #0
	; WORD optimization: a=a+b
	lda int+0
	
	clc
	adc #80
	bcc WordAdd21609
	inc int+1
WordAdd21609
	sta int+0
	; Assigning single variable : y
	lda #210
	sta y
	; Setting sprite position
	lda i
	pha
	tax
	lda #1
shiftbit25352
	cpx #0
	beq shiftbitdone1589
	asl
	dex
	jmp shiftbit25352
shiftbitdone1589
bitmask_var28573 = $54
	sta bitmask_var28573
	pla
	asl
	tax
	; integer assignment NodeVar
	ldy int+1 ; next one ; optimized, look out for bugs
	lda int
	sta $D000,x
	; integer assignment NodeVar
	ldy int+1 ; next one ; optimized, look out for bugs
	lda int+1
	beq spritepos6901
	lda $D010
	ora bitmask_var28573
	sta $D010
	jmp spriteposcontinue11045
spritepos6901
	lda #$FF
	eor bitmask_var28573
	sta bitmask_var28573
	lda $D010
	and bitmask_var28573
	sta $D010
spriteposcontinue11045
	inx
	txa
	tay
	lda y
	sta $D000,y
	; Set sprite location
	; 8 bit binop
	; Add/sub where right value is constant number
	lda #160
	clc
	adc i
	 ; end add / sub var with constant
	ldx i
	sta $07f8 + $0,x
	; Assigning single variable : $d027
	lda #4
	ldx i
	sta $d027,x

	inc i
	lda #8
	cmp i
	beq forLoopDone19894
	jmp for2671
forLoopDone19894

	rts
	
	
	; ***********  Defining procedure : UpdateRoad
	;    Procedure type : User-defined procedure
	
UpdateRoad

	; Assigning single variable : road
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub where right value is constant number
	lda road
	clc
	adc #1
	 ; end add / sub var with constant
	
	and #15
	 ; end add / sub var with constant
	
	sta road
	; Assigning single variable : k
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub where right value is constant number
	clc
	adc #1
	 ; end add / sub var with constant
	
	and #15
	 ; end add / sub var with constant
	
	sta k
	; Assigning single variable : k
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	
	asl
	
	sta k
	; Assigning single variable : zp
	lda #232
	ldx #33
	sta zp
	stx zp+1
	; Assigning single variable : j
	; Right is PURE NUMERIC
	; 8 bit mul of power 2
	
	lda road
	
	asl
	
	sta j
	; Assigning single variable : zp
	; Load Byte array
	ldx j
	lda roads,x
	
	ldy #6
	sta (zp),y
	; Assigning single variable : zp
	; Load Byte array
	; 8 bit binop
	; Add/sub where right value is constant number
	lda j
	clc
	adc #1
	 ; end add / sub var with constant
	
	tax
	lda roads,x
	
	pha
	ldy #14 ; optimized, look out for bugs
	
	pla
	sta (zp),y
	; Assigning single variable : zp
	; Load Byte array
	ldx k
	lda roads,x
	
	ldy #7
	sta (zp),y
	; Assigning single variable : zp
	; Load Byte array
	; 8 bit binop
	; Add/sub where right value is constant number
	lda k
	clc
	adc #1
	 ; end add / sub var with constant
	
	tax
	lda roads,x
	
	pha
	ldy #15 ; optimized, look out for bugs
	
	pla
	sta (zp),y

	rts
	
	
	; ***********  Defining procedure : InitRoad
	;    Procedure type : User-defined procedure
	
InitRoad

	; Assigning single variable : screenmemory
	lda #120
	ldx #4
	sta screenmemory
	stx screenmemory+1
	lda #255
	ldx #0
fill28277
	sta 8680,x
	inx
	cpx #16
	bne fill28277
	; Assigning single variable : i
	lda #0
	sta i
for32115

	; Binary clause Simplified: EQUALS
	; Load pointer array
	ldy i
	lda (screenmemory),y
	
	; Compare with pure num / var optimization
	cmp #83
	bne elsedoneblock8074
ConditionalTrueBlock14166

	; Assigning single variable : screenmemory
	; 8 bit binop
	; Add/sub where right value is constant number
	; 8 bit binop
	; Add/sub where right value is constant number
	lda i
	and #1
	 ; end add / sub var with constant
	
	clc
	adc #61
	 ; end add / sub var with constant
	
	ldy i
	sta (screenmemory),y

elsedoneblock8074

	inc i
	lda #40
	cmp i
	bne for32115
forLoopDone30967

	rts
	
	
	; ***********  Defining procedure : InitWaves
	;    Procedure type : User-defined procedure
	
InitWaves

	lda $D011
	and #%01101111
	sta $D011
	; Set bank
	lda #3
	sta $dd00
	; Clear screen with offset
	lda #32
	ldx #$00
clearloop19903
	sta $0000+$400,x
	sta $0100+$400,x
	sta $0200+$400,x
	sta $02e8+$400,x
	dex
	bne clearloop19903
	jsr InitSprites
	; Assigning single variable : $d021
	lda #0
	sta $d021+2
	; Assigning single variable : $d021
	lda #2
	sta $d021+1
	; Hide x border
	lda $D016
	and #$f7  ; change bit 4
	sta $D016
	; Assigning single variable : ffld
	lda #100
	sta ffld
	; Assigning single variable : val
	lda #1
	sta val
	; Assigning single variable : cur_start
	lda #0
	sta cur_start
	; ; Decrunch number direct
	lda #191
	sta opbase+1
	lda #30
	sta opbase+2
	jsr exod_decrunch
	; ; Decrunch number direct
	lda #75
	sta opbase+1
	lda #31
	sta opbase+2
	jsr exod_decrunch
	; Assigning single variable : tp
	lda #<text
	ldx #>text
	sta tp
	stx tp+1
	jsr InitStars
	; Assigning single variable : screenmemory
	lda #0
	ldx #4
	sta screenmemory
	stx screenmemory+1
	; Assigning single variable : i
	sta i
for29214

	; Assigning single variable : j
	lda #0
	sta j
for12010

	; Assigning single variable : screenmemory
	; Load pointer array
	ldy j
	lda (screenmemory),y
	
	ldy j
	sta (screenmemory),y

	inc j
	lda #40
	cmp j
	bne for12010
forLoopDone30066
	lda #40
	clc
	adc screenmemory
	bcc incscreenx12755
	inc screenmemory +1
incscreenx12755
	sta screenmemory

	inc i
	lda #25
	cmp i
	bne for29214
forLoopDone16050
	; initsid
	lda #0
	tax
	tay
	jsr $2b00
	; Hide x border
	lda $D016
	and #$f7  ; change bit 4
	sta $D016
	lda $d018
	and #%11110001
	ora #8
	sta $d018
	lda #0
	ldx #0
fill20157
	sta 9216,x
	inx
	cpx #0
	bne fill20157
	; Assigning single variable : tp2
	lda #<waves
	ldx #>waves
	sta tp2
	stx tp2+1
	jsr SetupFontTab
	jsr SetupSine2
	lda #4
	ldx #0
fill11323
	sta 55856,x
	inx
	cpx #40
	bne fill11323
	lda #3
	ldx #0
fill2303
	sta 55896,x
	inx
	cpx #40
	bne fill2303
	lda #7
	ldx #0
fill7469
	sta 56096,x
	inx
	cpx #40
	bne fill7469
	lda #4
	ldx #0
fill677
	sta 56136,x
	inx
	cpx #40
	bne fill677
	lda #7
	ldx #0
fill18404
	sta 56016,x
	inx
	cpx #80
	bne fill18404
	lda #3
	ldx #0
fill17444
	sta 55936,x
	inx
	cpx #80
	bne fill17444
	lda #32
	ldx #0
fill9374
	sta 1584,x
	inx
	cpx #160
	bne fill9374
	lda #32
	ldx #0
fill6128
	sta 1744,x
	inx
	cpx #160
	bne fill6128
	; Assigning single variable : i
	lda #0
	sta i
for617

	; wait for raster
	ldx #0
	cpx $d012
	bne *-3
	; wait for raster
	ldx #255
	cpx $d012
	bne *-3
	jsr $2b03

	inc i
	lda #105
	cmp i
	bne for617
forLoopDone1062
	lda $D011
	ora #%00010000
	and #%01111111
	sta $D011

	rts
	
	
	; ***********  Defining procedure : PrintWave
	;    Procedure type : User-defined procedure
	
PrintWave

	; 
	; ****** Inline assembler section

		ldy a
pwl:		tya
		adc ms_shift
		and #7
		adc #128
		sta (screenmemory),y
		adc #16
		sta (p1),y
		
		iny
		cpy b
		bne pwl

	
	

	rts
	
	
	; ***********  Defining procedure : nmi
	;    Procedure type : User-defined procedure
	
nmi


	rti
block7295

	sei
	; Disable interrupts
	ldy #$7f    ; $7f = %01111111
	sty $dc0d   ; Turn off CIAs Timer interrupts
	sty $dd0d   ; Turn off CIAs Timer interrupts
	lda $dc0d   ; cancel all CIA-IRQs in queue/unprocessed
	lda $dd0d   ; cancel all CIA-IRQs in queue/unprocessed
	
	; Hook NMI
	sei
	lda     #<nmi
	sta     $0318
	lda     #>nmi
	sta     $0319
	lda     #$00            ; Stop time A CIA2
	sta     $dd0e
	lda     #$00
	sta     $dd04           ; Set timer value #1 (Timer A CIA 2)
	sta     $dd05           ; Set timer value #2 (Timer A CIA 2)
	lda     #%10000001      ; Fill bit to 1 and enable NMI to occur from Timer A
	sta     $dd0d
	lda     #$01
	sta     $dd0e           ; Start timer A CIA (NMI will occur immediately)(*)
	cli
	; Set Memory Config
	lda $01
	and #%11111000
	ora #%101
	sta $01
	jsr InitWaves
	; RasterIRQ : Hook a procedure
	lda #0
	sta $d012
	lda #<RasterTop
	sta $fffe
	lda #>RasterTop
	sta $ffff
	; Enable raster IRQ
	lda $d01a
	ora #$01
	sta $d01a
	lda #$1B
	sta $d011
	asl $d019
	cli
	jmp * ; loop like (?/%

EndSymbol
	org $1e00
logo_col
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/C64/4kDreams///compressed//logo_col_c.bin"
	org $1ebf
logo_chars
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/C64/4kDreams///compressed//logo_chars_c.bin"
	org $2000
charset
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/C64/4kDreams///charsets/charset.bin"
	org $2800
sprites
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/C64/4kDreams///images/trse.bin"
	org $2a00
FontTab	dc.b	 
	org FontTab+256
EndBlock75
	org $2b00
	incbin "C:/Users/leuat/OneDrive/Documents/GitHub/TRSE/Publish/tutorials/C64/4kDreams//music/_exhale2B.dat"
